<ion-header>
  <ion-toolbar>
    <ion-buttons slot="start">
      <ion-button (click)="navigateBack()">
        <ion-icon slot="icon-only" name="arrow-back"></ion-icon>
      </ion-button>
    </ion-buttons>
    <ion-title>Warranty</ion-title>
  </ion-toolbar>
</ion-header>

<ion-content class="page-background">
  <form [formGroup]="warrantyForm">
    <ion-card>
      <ion-card-header style="padding-bottom: 0">
        <ion-row class="align">
          <ion-col>
            <ion-card-title>
              <ion-text color="tertiary"> Warranty Claims </ion-text>
            </ion-card-title>
          </ion-col>

          <ion-col class="ion-text-right">
            <ion-button
              color="tertiary"
              [disabled]="!dataSource.length"
              (click)="downloadSerials()"
              fill="outline"
            >
              Download CSV
            </ion-button>
            <ion-button
              *ngIf="permissionState.warranty_claim.create"
              color="tertiary"
              [routerLink]="['/warranty/add-warranty-claim']"
            >
              Add
            </ion-button>
          </ion-col>
        </ion-row>
      </ion-card-header>

      <div class="loading-shade" *ngIf="dataSource.loading$ | async">
        <mat-progress-bar
          *ngIf="dataSource.loading$ | async"
          mode="indeterminate"
        >
        </mat-progress-bar>
      </div>

      <ion-card-content class="ion-no-padding">
        <ion-grid>
          <ion-row>
            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Customer"
                  [matAutocomplete]="customer"
                  formControlName="customer_name"
                  (focusout)="validateInput(f.customer_name, filteredCustomerList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #customer="matAutocomplete"
                  [displayWith]="getCustomerOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredCustomerList | async"
                    [value]="option"
                  >
                    {{ option.customer_name }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.customer_name.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.customer_name.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  formControlName="claim_no"
                  placeholder="Claim No"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  formControlName="third_party_name"
                  placeholder="Third Party"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Product"
                  [matAutocomplete]="product"
                  formControlName="product"
                  (focusout)="validateInput(f.product, filteredProductList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #product="matAutocomplete"
                  [displayWith]="getProductOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredProductList | async"
                    [value]="option"
                  >
                    {{ option.item_name }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.product.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.product.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Brand"
                  [matAutocomplete]="brand"
                  formControlName="brand"
                  (focusout)="validateInput(f.brand, filteredBrandList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #brand="matAutocomplete"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredBrandList | async"
                    [value]="option"
                  >
                    {{option}}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.brand.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.brand.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>
          </ion-row>

          <ion-row>
            <ion-col>
              <mat-form-field class="full-width">
                <mat-label>Claim Status</mat-label>
                <mat-select
                  formControlName="claim_status"
                  (selectionChange)="statusChange($event.value)"
                >
                  <mat-option
                    *ngFor="let status of claimStatusList"
                    [value]="status"
                  >
                    {{status}}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <mat-label>Claim type</mat-label>
                <mat-select
                  formControlName="claim_type"
                  (selectionChange)="setFilter()"
                >
                  <mat-option *ngFor="let claim of claimList" [value]="claim">
                    {{claim}}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Branch"
                  [matAutocomplete]="territory"
                  formControlName="territory"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #territory="matAutocomplete"
                  [displayWith]="getOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredTerritoryList | async"
                    [value]="option"
                  >
                    {{ option }}
                  </mat-option>
                </mat-autocomplete>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Serial Number"
                  formControlName="serial_no"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Replaced Serial Number"
                  formControlName="replace_serial"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>
          </ion-row>

          <ion-row>
            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Received By"
                  formControlName="received_by"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <input
                  matInput
                  placeholder="Delivered By"
                  formControlName="delivered_by"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <mat-label>Date type</mat-label>
                <mat-select
                  formControlName="date_type"
                  (selectionChange)="setFilter()"
                >
                  <mat-option
                    *ngFor="let dateType of dateTypeList"
                    [value]="dateType"
                  >
                    {{dateType}}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </ion-col>

            <ion-col>
              <mat-form-field class="full-width">
                <mat-label>Enter a date range</mat-label>
                <mat-date-range-input [rangePicker]="date_range_picker">
                  <input
                    readonly
                    matStartDate
                    placeholder="From Date"
                    formControlName="from_date"
                  />
                  <input
                    readonly
                    matEndDate
                    placeholder="To Date"
                    formControlName="to_date"
                    (dateChange)="setFilter()"
                  />
                </mat-date-range-input>
                <mat-datepicker-toggle matSuffix [for]="date_range_picker">
                </mat-datepicker-toggle>
                <mat-date-range-picker
                  #date_range_picker
                  [disabled]="!this.f.date_type.value"
                >
                </mat-date-range-picker>
              </mat-form-field>
            </ion-col>
          </ion-row>

          <ion-row>
            <ion-col class="ion-text-right">
              <ion-button
                color="tertiary"
                (click)="clearFilters()"
                fill="outline"
              >
                Clear
              </ion-button>
              <ion-button
                color="tertiary"
                [fill]="bulkFlag?'solid':'outline'"
                (click)="getBulkClaims()"
              >
                Bulk Claims
              </ion-button>
            </ion-col>
          </ion-row>
        </ion-grid>

        <div class="example-container mat-elevation-z8">
          <mat-table
            class="full-width-table"
            matSort
            aria-label="Elements"
            [dataSource]="dataSource"
            (matSortChange)="getUpdate($event)"
          >
            <ng-container matColumnDef="sr_no">
              <mat-header-cell *matHeaderCellDef>No. </mat-header-cell>
              <mat-cell *matCellDef="let row;let i=index ">
                {{ paginator.pageIndex * paginator.pageSize + 1 + i }}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="claim_no">
              <mat-header-cell *matHeaderCellDef mat-sort-header="claim_no">
                Claim no
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                <a
                  *ngIf="row.set==='Bulk'"
                  [routerLink]="['/bulk-warranty-claim', row.claim_no,row.uuid]"
                >
                  {{row.claim_no || 'Draft'}}
                </a>
                <a
                  *ngIf="row.set === 'Single' || row.set ==='Part'"
                  [routerLink]="['/warranty/view-warranty-claims', row.uuid]"
                >
                  {{row.claim_no || 'Draft'}}
                </a>
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="claim_type">
              <mat-header-cell *matHeaderCellDef mat-sort-header="claim_type">
                Claim Type
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.claim_type}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="received_on">
              <mat-header-cell *matHeaderCellDef mat-sort-header="received_on">
                Received Date
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.received_on }} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="customer_name">
              <mat-header-cell *matHeaderCellDef>
                Customer name
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.customer}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="third_party_name">
              <mat-header-cell *matHeaderCellDef>
                Third Party Customer Name
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{row.third_party_name}}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="item_code">
              <mat-header-cell *matHeaderCellDef> Item </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.item_code}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="claimed_serial">
              <mat-header-cell *matHeaderCellDef>
                Claimed Serial
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.serial_no}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="claim_status">
              <mat-header-cell *matHeaderCellDef>
                Claim Status
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.claim_status}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="receiving_branch">
              <mat-header-cell *matHeaderCellDef>
                Receiving Branch
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{row.receiving_branch}}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="delivery_branch">
              <mat-header-cell *matHeaderCellDef>
                Delivery Branch
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{row.delivery_branch}}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="received_by">
              <mat-header-cell *matHeaderCellDef> Received By </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.received_by}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="delivered_by">
              <mat-header-cell *matHeaderCellDef>
                Delivered by
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.delivered_by}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="product_brand">
              <mat-header-cell *matHeaderCellDef> Brand </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.product_brand}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="replace_serial">
              <mat-header-cell *matHeaderCellDef>
                Replaced Serial
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{row.replace_serial}}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="problem">
              <mat-header-cell *matHeaderCellDef> Problem </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.problem}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="verdict">
              <mat-header-cell *matHeaderCellDef> Verdict </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{row.status_history?row.status_history[row.status_history.length-1].verdict:''}}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="delivery_date">
              <mat-header-cell *matHeaderCellDef>
                Delivery Date
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.delivery_date}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="billed_amount">
              <mat-header-cell *matHeaderCellDef>
                Billed Amount
              </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.billed_amount}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="outstanding_amount">
              <mat-header-cell *matHeaderCellDef>
                Outstanding Amount
              </mat-header-cell>
              <mat-cell *matCellDef="let row">
                {{ row.outstanding_amount }}
              </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <ng-container matColumnDef="remarks">
              <mat-header-cell *matHeaderCellDef> Remarks </mat-header-cell>
              <mat-cell *matCellDef="let row"> {{row.remarks}} </mat-cell>
              <mat-footer-cell *matFooterCellDef></mat-footer-cell>
            </ng-container>

            <mat-header-row *matHeaderRowDef="displayedColumns; sticky: true">
            </mat-header-row>
            <mat-row
              *matRowDef="let row; columns: displayedColumns;"
              [ngStyle]="{
                'background-color':row.claim_status==='Cancelled' ? '#F8DEDE' : 
                row.set==='Bulk' ? '#F4F4FB' :
                row.set==='Part' ? '#FDFAE5' : 'rgb(255, 255, 255)'
              }"
            >
            </mat-row>
            <mat-footer-row
              class="footer"
              *matFooterRowDef="displayedColumns; sticky: true"
            >
            </mat-footer-row>
          </mat-table>
        </div>
        <mat-card-actions>
          <mat-paginator
            #paginator
            class="mat-paginator-sticky"
            (page)="getUpdate($event)"
            [length]="dataSource.length"
            [pageSizeOptions]="[30, 50, 100, 500]"
          >
          </mat-paginator>
        </mat-card-actions>
      </ion-card-content>
    </ion-card>
  </form>
</ion-content>
